<?php
namespace api;

include_once("../lib/f_proxy.php");
include_once("./_link.php");

p_include("core/php/crud.php","");
p_include("core/php/util.php","");
p_include("core/php/api.php","");
p_include("core/php/auth.php","");

use core;
use api;

abstract class Entity extends core\API
{
    public function __construct() 
    {
        $settings = core\getSettings("../lib"); 
        $db = core\getVal($settings,"db");
        $this->crud = new  core\Crud($db);
        $this->table = "entity";
        $this->auth = new core\Auth();

        
        $type = get_class($this);
        
        if(gettype($type)=="string") 
        {
            $type = explode('\\',$type);
            $type = end($type);
            
            $this->table = strtolower($type);
            $this->link = new Link($this->table);
        }
       
        $this->build();

        $this->startSession();
        $this->_run();
    }

    function  build()
	{
		$fields=
        [
            "data JSON"
        ];

		$res = $this->crud-> buildTable($this->table,$fields);


        $res = json_encode($res);
    }

    function prepareData($input)
    {
        if(!$input) return $input;

    
        $data = core\getVal($input,"data",[]);

        $cols = ["id"];

        return core\filterArray($data,$cols);
    }

    public function save($input=[])
    {
        $res = [];
        
        $input = $this->prepareData($input);

        $req = 
        [
            "table" => $this->table,
            "data" => $input,
        ];


        $res = $this->crud->save($req);
        
        $data = core\getVal($res,'data',[]);
        $json = core\getVal($data,'data',"");
        $res["data"] = array_merge_recursive( $res["data"] ,json_decode($json,true));

        return core\getVal($res,'data',[]);
    }

    public function list($input = [])
    {
        $where = core\getVal($input,'where',"");

        $table = $this->table;
        $input["where"] = $where;
        $input["table"] = $this->table;
        $input["fields"] =["*","'$table' as type"];
        $input["order_fields"] =["data->'$.name'"];
        $input["setId"] = true;
        
        $res = $this->crud->read($input);
        $rows = core\getval( $res,"data",[]);
        return $rows;
    }

    function view($input=[])
    {
        $id = core\getVal($input,"id",-100);
        $where = core\getVal($input,"where");
        $table = core\getVal($input,"table",$this->table);
        if(!$where)
        {
            $req["where"] = "WHERE id = UUID_TO_BIN('$id')";
        } 
        else $req["where"] = $where;


        $req["fields"] = core\getVal($input,"fields",["*"]);
        $req["table"] = $this->table;
        $req["setId"] = true;
        $req["limit"] = 1;
        $res = $this->crud->read($req);
        return reset(core\getVal($res,'data',[]));

    }
    
    public function delete($input=[])
    {
        $req["data"] = $input;
        $req["table"] = $this->table;
        $res = $this->crud->delete($req);
        return  $res;
    }

    public function getCount()
    {
        $type = $this->table;
        $req["table"] = $this->table;
        $req["where"] = "WHERE type = '$type'";
        
        return $this->crud->getCount($req);
    }

    public function link_save($input=[])
    {
        $res = $this->link->save( $input);
        
        return $res;
    }

    public function link_remove($input=[])
    {
        $res =  $this->link->delete($input);
        
        return $res;
    }

    public function link_list($input=[])
    {
        $res = $this->link->list($input);
        $rows = core\getval( $res,"data",[]);

        return $rows;
    }

   
}